﻿SIEB = {}
SIEB.showPercentageText = true
SIEB.showCurrentMaxText = true
SIEB.alpha = 0.6
SIEB.name = "SlightlyImprovedExperienceBar"
SIEB.version = "1.56"

function SIEB.Initialize(eventCode, addOnName)
	if (SIEB.name ~= addOnName) then return end
	-- saved variables
	local defaults = {showPercentageText = true, showCurrentMaxText = true, alpha = 0.6}
	SIEB.sv = ZO_SavedVars:NewAccountWide( 'SIEBVars', 1.44, nil, defaults)
	if SIEB.sv then
		if SIEB.sv.showPercentageText ~= nil then SIEB.showPercentageText = SIEB.sv.showPercentageText end
		if SIEB.sv.showCurrentMaxText ~= nil then SIEB.showCurrentMaxText = SIEB.sv.showCurrentMaxText end
		if SIEB.sv.showCPRank ~= nil then SIEB.showCPRank = SIEB.sv.showCPRank end
		if SIEB.sv.alpha ~= nil then SIEB.alpha = SIEB.sv.alpha end
	end
	-- settings
	local LAM = LibStub("LibAddonMenu-1.0")
	if LAM then
		SIEB.settings = LAM:CreateControlPanel("_SIEBPanel", "SIExperienceBar")
		LAM:AddHeader(SIEB.settings, "_settings", "Settings")
		LAM:AddCheckbox(SIEB.settings, "_percent", "Show percentage text", "Enable or disable percentage display",
		function() return SIEB.showPercentageText end, function(value) SIEB.showPercentageText = value SIEB.sv.showPercentageText = SIEB.showPercentageText SIEB.UpdateLabel(SIEB.FormatLabelText(GetUnitXP("player"), GetUnitXPMax("player"))) if IsUnitVeteran("player") then SIEB.UpdateCXPLabel(SIEB.FormatLabelText(GetPlayerChampionXP(), GetNumChampionXPInChampionPoint(GetPlayerChampionPointsEarned()))) end end)
		LAM:AddCheckbox(SIEB.settings, "_currentmax", "Show XP current / max", "Enable or disable current and max XP display",
		function() return SIEB.showCurrentMaxText end, function(value) SIEB.showCurrentMaxText = value SIEB.sv.showCurrentMaxText= SIEB.showCurrentMaxText SIEB.UpdateLabel(SIEB.FormatLabelText(GetUnitXP("player"), GetUnitXPMax("player"))) if IsUnitVeteran("player") then SIEB.UpdateCXPLabel(SIEB.FormatLabelText(GetPlayerChampionXP(), GetNumChampionXPInChampionPoint(GetPlayerChampionPointsEarned()))) end end)
		LAM:AddCheckbox(SIEB.settings, "_cprank", "Show enlightenment", "Enable or disable champion enlightenment pool display",
		function() return SIEB.showCPRank end, function(value) SIEB.showCPRank = value SIEB.sv.showCPRank = SIEB.showCPRank if IsUnitVeteran("player") and SIEB.showCPRank then SIEB.UpdateCPRLabel(SIEB.GetChampionRankText()) else SIEB.UpdateCPRLabel("") end end)
		LAM:AddSlider(SIEB.settings, '_alpha', 'XP Bar Transparency', "Set XP Bar transparency level by percentage", 0, 90, 1, 
		function() return zo_round(100-100*SIEB.alpha) end, function(value) SIEB.alpha = (100-value)/100 SIEB.sv.alpha = SIEB.alpha SIEB.experienceBar:SetAlpha(SIEB.alpha) end)
	end
	-- label
	local parent = _G["ZO_PlayerProgressBar"]
	local label = WINDOW_MANAGER:CreateControl("SIEB_ExperienceBarLabel", parent, CT_LABEL)
	label:SetFont("ZoFontGame")
	label:SetColor(0.9, 0.9, 0.9, 1)
	label:SetHorizontalAlignment(1)
	local cplabel = WINDOW_MANAGER:CreateControl("SIEB_ChampionExperienceBarLabel", parent, CT_LABEL)
	cplabel:SetFont("ZoFontGame")
	cplabel:SetColor(0.9, 0.9, 0.9, 1)
	cplabel:SetHorizontalAlignment(1)
	local cprlabel = WINDOW_MANAGER:CreateControl("SIEB_ChampionRankLabel", parent, CT_LABEL)
	cprlabel:SetFont("ZoFontGame")
	cprlabel:SetColor(0.9, 0.9, 0.9, 1)
	cprlabel:SetHorizontalAlignment(1)
	if (IsUnitVeteran("player")) then label:SetHorizontalAlignment(2) end
	label:SetVerticalAlignment(1)
	SIEB.experienceBar = parent
	SIEB.experienceLabel = label
	SIEB.ChampionExperienceLabel = cplabel
	SIEB.ChampionRankLabel = cprlabel
	local cxp = GetPlayerChampionXP()
	local exp = GetUnitXP("player")
	local maxExp = GetUnitXPMax("player")

	SIEB.UpdateLabel(SIEB.FormatLabelText(exp, maxExp))
	SIEB.UpdateCXPLabel(SIEB.FormatLabelText(cxp, GetNumChampionXPInChampionPoint(GetPlayerChampionPointsEarned())))
	if IsUnitVeteran("player") and SIEB.showCPRank then SIEB.UpdateCPRLabel(SIEB.GetChampionRankText()) end
	-- xp bar visibility
	SCENE_MANAGER:GetScene("hud"):AddFragment(PLAYER_PROGRESS_BAR_FRAGMENT)
	SCENE_MANAGER:GetScene("hudui"):AddFragment(PLAYER_PROGRESS_BAR_FRAGMENT)
	SCENE_MANAGER:GetScene("hud"):AddFragment(PLAYER_PROGRESS_BAR_CURRENT_FRAGMENT)
	SCENE_MANAGER:GetScene("hudui"):AddFragment(PLAYER_PROGRESS_BAR_CURRENT_FRAGMENT)
	SIEB.experienceBar:SetAlpha(SIEB.alpha)
	-- updates registration
	ZO_PreHook(SIEB.experienceBar, "SetHidden", function() zo_callLater(SIEB.SetAlpha,300) end)
	EVENT_MANAGER:RegisterForEvent("SIEB", EVENT_EXPERIENCE_UPDATE, SIEB.ExperienceUpdate)
end

function SIEB.SetAlpha()
	SIEB.experienceBar:SetAlpha(SIEB.alpha)
end
-- label string formatting
function SIEB.FormatLabelText(current, max)
	local percent = 0
	if max == nil then
		max = current
	end
	if (max > 0) then
		percent = math.floor((current/max) * 100)
	end
	local str = ""
	if (SIEB.showCurrentMaxText) then
		str = str .. FormatIntegerWithDigitGrouping(current,",",3) .. "/" .. FormatIntegerWithDigitGrouping(max,",",3)
	end
	if (SIEB.showPercentageText) then
		if (SIEB.showCurrentMaxText) then
			str = str .. "  "
		end
		str = str .. percent .. "%"
	end
	return str
end

function SIEB.UpdateLabel(text)
	local space = 0
	if SIEB.showPercentageText then
		space = 5
	end

--	if IsUnitVeteran("player") and GetCVar("language.2") == "de" then
--		space = space + 8 -- Fix for German veteran players
--	end

	if (IsUnitVeteran("player")) then
		text = ""
	end

	SIEB.experienceLabel:SetDimensions(160, 22)
	SIEB.experienceLabel:SetText(text)
	SIEB.experienceLabel:SetDimensions(SIEB.experienceLabel:GetTextWidth(), SIEB.experienceLabel:GetTextHeight())
	SIEB.experienceLabel:ClearAnchors()
	SIEB.experienceLabel:SetAnchor(TOPLEFT, SIEB.experienceBar, TOPLEFT, space+SIEB.experienceBar:GetWidth()-SIEB.experienceLabel:GetTextWidth(), -22)
end

function SIEB.UpdateCXPLabel(text)
	local space = 0
	if SIEB.showPercentageText then
		space = 5
	end

--	if IsUnitVeteran("player") and GetCVar("language.2") == "fr" then
--		space = space + 24 -- Fix for French veteran players
--	end

--	if IsUnitVeteran("player") and GetCVar("language.2") == "de" then
--		space = space + 16 -- Fix for German veteran players
--	end
	if IsUnitVeteran("player") then
		SIEB.ChampionExperienceLabel:SetDimensions(160, 22)
		SIEB.ChampionExperienceLabel:SetText(text)
		SIEB.ChampionExperienceLabel:SetDimensions(SIEB.ChampionExperienceLabel:GetTextWidth(), SIEB.ChampionExperienceLabel:GetTextHeight())
		SIEB.ChampionExperienceLabel:ClearAnchors()
		SIEB.ChampionExperienceLabel:SetAnchor(BOOTOMLEFT, SIEB.experienceBar, BOTTOMLEFT, space+SIEB.experienceBar:GetWidth()-SIEB.ChampionExperienceLabel:GetTextWidth(), 7)
	end
end

function SIEB.UpdateCPRLabel(text)
	local space = 0
	-- space may need some adjustments
	SIEB.ChampionRankLabel:SetDimensions(220, 22)
	SIEB.ChampionRankLabel:SetText(text)
	SIEB.ChampionRankLabel:SetDimensions(SIEB.ChampionRankLabel:GetTextWidth(), SIEB.ChampionRankLabel:GetTextHeight())
	SIEB.ChampionRankLabel:ClearAnchors()
	SIEB.ChampionRankLabel:SetAnchor(BOOTOMLEFT, SIEB.experienceBar, BOTTOMLEFT, space+SIEB.experienceBar:GetWidth()-SIEB.ChampionRankLabel:GetTextWidth(), 29)
end

function SIEB.GetChampionRankText()
	local str = ""
	if GetCVar("language.2") == "en" then
		str = "Enlightenment: "..FormatIntegerWithDigitGrouping(GetEnlightenedPool()*(1+GetEnlightenedMultiplier()),",",3)
	end
	if GetCVar("language.2") == "de" then
		str = "Erfrischung: "..FormatIntegerWithDigitGrouping(GetEnlightenedPool()*(1+GetEnlightenedMultiplier()),",",3)
	end
	if GetCVar("language.2") == "fr" then
		str = "Illuminé: "..FormatIntegerWithDigitGrouping(GetEnlightenedPool()*(1+GetEnlightenedMultiplier()),",",3)
	end
	return str
end
-- Callback for the experience update event
function SIEB.ExperienceUpdate(reason, unitTag, currentExp, maxExp)
	if (unitTag ~= "player") then return end
	if (IsUnitVeteran("player")) then
		SIEB.UpdateCXPLabel(SIEB.FormatLabelText(GetPlayerChampionXP(), GetNumChampionXPInChampionPoint(GetPlayerChampionPointsEarned())))
		if SIEB.showCPRank then
			SIEB.UpdateCPRLabel(SIEB.GetChampionRankText())
		else
			SIEB.UpdateCPRLabel("")
		end
	else
		SIEB.UpdateCXPLabel("")
	end
	SIEB.UpdateLabel(SIEB.FormatLabelText(currentExp, maxExp))
end

function SIEB.CommandHandler(text)
	if IsUnitVeteran("player") then
		d("|cE0F0F0["..GetTimeString().."] Champion Rank: "..tostring(GetPlayerChampionPointsEarned()) .."  ".. SIEB.FormatLabelText(GetPlayerChampionXP(), GetNumChampionXPInChampionPoint(GetPlayerChampionPointsEarned())) .. "|r")
	if IsEnlightenedAvailableForCharacter() then
		d("|cE0F0F0["..GetTimeString().."] Available Enlightenment: "..tostring(GetEnlightenedPool()*(1+GetEnlightenedMultiplier())) .. "|r")
	end
	else
		d("|cE0F0F0["..GetTimeString().."] Character Level: "..tostring(GetUnitEffectiveLevel("player")) .."  ".. SIEB.FormatLabelText(GetUnitXP("player"), GetUnitXPMax("player")) .. "|r")
	end
 end


EVENT_MANAGER:RegisterForEvent("SIEB", EVENT_ADD_ON_LOADED, SIEB.Initialize)
SLASH_COMMANDS["/xp"] = SIEB.CommandHandler